/// @description Insert description here
// You can write your code in this editor

if (iControl.estado == EST_JUGANDO) {
	if (mouse_check_button_pressed(mb_left)) {
		if ((mouse_y == clamp(mouse_y, 16, 248)) && (mouse_x == clamp(mouse_x, 8, 312))) {
			var posicion = ds_map_create();
			posicion[? "x"] = clamp(mouse_x, 24, 296);
			posicion[? "y"] = clamp(mouse_y, 64, 248);
			posicion[? "t"] = 0;
			ds_queue_enqueue(posicionesQueue, posicion);
		}
	}
	
	var coberturaActual = 0;
	for (var i = 0; i < instance_number(o6g); i++) {
      var i6g = instance_find(o6g, i);
	  var distancia6g = point_distance(i6g.x, i6g.y, iProta.x, iProta.y);
	  coberturaActual += clamp(180 - distancia6g, 0, 180) * i6g.fuerza;
    }
	
	cobertura = 4 - clamp(coberturaActual * 0.0002, 0, 4);
	global.iCobertura.image_index = cobertura;

	if ((posicionActual == noone) && (!ds_queue_empty(posicionesQueue))) {
		posicionActual = ds_queue_dequeue(posicionesQueue);
		iProta.sprite_index = sprProtaCorriendo;
	} else {
		iProta.sprite_index = sprProta;
	}

	if (posicionActual != noone) {
		posicionActual[? "t"]++;
		var fuerza = 100 - posicionActual[? "t"];
	
		iProta.image_xscale = (posicionActual[? "x"] <= iProta.x) ? 1 : -1;
		
		var xAnt = iProta.x;
		var yAnt = iProta.y;
	
		iProta.x = (iProta.x * (fuerza) + posicionActual[? "x"] * posicionActual[? "t"]) * 0.01;
		iProta.y = (iProta.y * (fuerza) + posicionActual[? "y"] * posicionActual[? "t"]) * 0.01;
		
		var velocidadMomento = point_distance(xAnt, yAnt, iProta.x, iProta.y);
		
		if (velocidadMomento > 2) {
			for (var i = 0; i < instance_number(oAspiradora); i++) {
		      var iAspiradora = instance_find(oAspiradora, i);
			  var distanciaAspiradora = point_distance(iAspiradora.x, iAspiradora.y, iProta.x, iProta.y);
			  if (distanciaAspiradora < 16) {
				  iControl.estado = EST_CAIDO;
				  audio_play_sound(sndFracaso, 1, false);
				  iProta.sprite_index = sprProtaCaido;
				  iControl.iVentanaPortatil.image_alpha = 1;
				  iControl.iVentanaPortatil.sprite_index = sprVentanaRota;
				  iControl.iBotonInicio.sprite_index = sprBotonRetry;
			  }
		    }
		}
		
	
		//if (point_distance(iProta.x, iProta.y, posicionActual[? "x"], posicionActual[? "y"])
	
		if (((posicionActual[? "t"] >= 100) || (((iProta.x == posicionActual[? "x"]) && (iProta.y == posicionActual[? "y"])))) || (!ds_queue_empty(posicionesQueue) && ((point_distance(iProta.x, iProta.y, posicionActual[? "x"], posicionActual[? "y"]) < 10)))) {
			ds_map_clear(posicionActual);
			posicionActual = noone;
		}
	}

	if (irandom_range(0, 401) >= 400) {
		i6g = instance_create_depth(irandom_range(24, 296), irandom_range(64, 248), -1000, o6g);
		i6g.iControl = iControl;
		i6g.depth = -i6g.y-2;
	}
}

